try:
    from pysqlite2 import dbapi2 as sqlite
except ImportError:
    from sqlite3 import dbapi2 as sqlite

def pysqlite_bug(show_bug):
    con = sqlite.connect('test.db')
    cur = con.cursor()

    ##
    # prepare test data
    cur.execute("DROP TABLE IF EXISTS t1")
    cur.execute("DROP TABLE IF EXISTS t2")
    cur.execute("CREATE TABLE t1(id INTEGER PRIMARY KEY, data TEXT)")
    cur.execute("CREATE TABLE t2(id INTEGER PRIMARY KEY, data TEXT)")

    cur.execute("INSERT INTO t1(id, data) VALUES (1, 'one')")
    cur.execute("INSERT INTO t1(id, data) VALUES (2, 'two')")

    con.commit()

    #
    ##

    ##
    # demonstrate bug

    cur.execute("UPDATE t1 SET data=? WHERE id=?", ('first', 1))

    cur.execute("ALTER TABLE t2 ADD COLUMN comment TEXT")

    if show_bug:
        cur.execute("UPDATE t1 SET data=? WHERE id=?", ('second', 2))
    else:
        cur.execute("UPDATE t1 SET data=? WHERE  id=?", ('second', 2))

    con.commit()

    cur.execute("SELECT * FROM t1")
    result = cur.fetchall()
    assert result == [(1, 'first'), (2, 'second')], result

    #
    ##

    print "Done."

if __name__ == "__main__":
    print "Using pysqlite version", sqlite.version, "sqlite version", sqlite.sqlite_version

    print "Don't trigger the bug"
    pysqlite_bug(False)
    print "Trigger the bug"
    pysqlite_bug(True)
